
// Ancora esercizi sui cicli

public class Esempio1Sol {

	static int i;
	static int n;
	static int m;
	static int somma;
	static int fatt;
	static int quadrato;
	static int radice;
	
	public static void main(String[] args) {
		
		// Esercizio 1.
		// Stampate i numeri pari da 0 a 20.
		// Potete fare scorrere i da 0 a 20 e usare un if per scartare
		// i dispari. (Usate l'operatore modulo a%b)
		// Alternativamente, potete incrementare di due i ad ogni iterazione.

		// Soluzione (A)
		
		i = 0;
		while (i <= 20) {
			if (i % 2 == 0) {
				System.out.println("i = " + i);
			}
			i++;
		}
		
		// Soluzione (B)
		
		i = 0;
		// INV: i è pari
		while (i <= 20) {
			System.out.println("i = " + i);
			i = i + 2;
		}
		
		// Esercizio 2.
		// Dato n>=0, sommate 1+2+...+n.
		
		// Soluzione
		n = 10;
		i = 0;
		somma = 0;
		// INV: somma = 0+1+2+...+i
		while (i <= n) {
			somma = somma + i;
			i++;
		}
		System.out.println("1+2+...+" + n + " = " + somma);

		// Esercizio 3.
		// Dato n>=0, calcolate il fattoriale n! = 1*2*...*n.
		
		// Soluzione
		
		n = 10;
		i = 1;
		fatt = 1;
		// INV: fatt = 1*2*...*i
		while (i <= n) {
			fatt = fatt * i;
			i++;
		}
		System.out.println(n + "! = " + fatt);

		
		// Esercizio 4.
		// Dato n>=0, verificate se n è un quadrato.
		// Per farlo, provate a confrontarlo con m*m per ogni m<=n.
		// Se è un quadrato, impostate la variabile quadrato a 1 e radice
		// alla sua radice, altrimenti impostate quadrato a 0;

		// Soluzione
		
		n = 100;
		quadrato = 0;
		m = 0;
		// INV: se esiste 0<=i<m con i*i=n allora quadrato=1, altrimenti
		// quadrato=0. Inoltre, se quadrato=1, allora radice*radice=n.
		while (m <= n) {
			if (m*m == n) {
				radice = m;
				quadrato = 1;
			}
			m++;
		}
		if (quadrato == 1) {
			System.out.println(n + " è il quadrato di " + radice);			
		} else {
			System.out.println(n + " NON è un quadrato");
		}

		// Esercizio 5.
		// Nell'esercizio precedente, quando viene scoperta la radice, 
		// non serve provare il resto dei numeri. Modificate la guardia del
		// while in modo che in tal caso si fermi subito.

		// Soluzione
		
		n = 65536;
		quadrato = 0;
		m = 0;
		// INV: se esiste 0<=i<m con i*i=n allora quadrato=1, altrimenti
		// quadrato=0. Inoltre, se quadrato=1, allora radice*radice=n.
		while (m <= n && quadrato == 0) {
			if (m*m == n) {
				radice = m;
				quadrato = 1;
			}
			m++;
		}
		
		if (quadrato == 1) {
			System.out.println(n + " è il quadrato di " + radice);			
		} else {
			System.out.println(n + " NON è un quadrato");
		}
	}
}
